diff --git a/src/blackberry_ES10_fmt_plug.c b/src/blackberry_ES10_fmt_plug.c
index 0afc100f04..444df64c3d 100644
--- a/src/blackberry_ES10_fmt_plug.c
+++ b/src/blackberry_ES10_fmt_plug.c
@@ -215,20 +215,17 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			SHA512_Update(&ctx, cur_salt->salt, strlen((char*)cur_salt->salt));
 			SHA512_Final(tmpBuf, &ctx);
 			p64 = &keys64[i%SIMD_COEF_64+i/SIMD_COEF_64*SHA_BUF_SIZ*SIMD_COEF_64];
-#if ARCH_LITTLE_ENDIAN==1
 			for (j = 0; j < 8; ++j)
+#if ARCH_LITTLE_ENDIAN==1
 				p64[j*SIMD_COEF_64] = JOHNSWAP64(tmpBuf64[j]);
-			p64[8*SIMD_COEF_64] = 0x8000000000000000ULL;
 #else
-			for (j = 0; j < 8; ++j)
 				p64[j*SIMD_COEF_64] = tmpBuf64[j];
-			p64[8*SIMD_COEF_64] = 0x80;
 #endif
+			p64[8*SIMD_COEF_64] = 0x8000000000000000ULL;
 			p64[15*SIMD_COEF_64] = 0x200;
 		}
 		for (j = 0; j < 98; j++)
 			SIMDSHA512body(keys, keys64, NULL, SSEi_MIXED_IN|SSEi_OUTPUT_AS_INP_FMT);
-		// Last one with FLAT_OUT
 		SIMDSHA512body(keys, (uint64_t*)crypt_out[index], NULL, SSEi_MIXED_IN|SSEi_OUTPUT_AS_INP_FMT|SSEi_FLAT_OUT);
 #else
 		SHA512_Init(&ctx);
diff --git a/src/citrix_ns_fmt_plug.c b/src/citrix_ns_fmt_plug.c
index 5c4b5de98b..1380495d8f 100644
--- a/src/citrix_ns_fmt_plug.c
+++ b/src/citrix_ns_fmt_plug.c
@@ -83,8 +83,12 @@ john_register_one(&fmt_ctrxns);
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT              NBKEYS
 #define MAX_KEYS_PER_CRYPT              NBKEYS
+#if ARCH_LITTLE_ENDIAN==1
 #define GETPOS(i, index)                ((index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + (((i)&3)^3) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*SIMD_COEF_32*4) //for endianity conversion
 #else
+#define GETPOS(i, index)                ((index&(SIMD_COEF_32-1))*4 + ((i)&(0xffffffff-3))*SIMD_COEF_32 + ((i)&3) + (unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*SIMD_COEF_32*4) //for endianity conversion
+#endif
+#else
 #define MIN_KEYS_PER_CRYPT              1
 #define MAX_KEYS_PER_CRYPT              1
 #endif
@@ -158,7 +162,7 @@ static void *get_binary(char *ciphertext)
 		realcipher[i] = atoi16[ARCH_INDEX(ciphertext[i * 2])] * 16
 			+ atoi16[ARCH_INDEX(ciphertext[i * 2 + 1])];
 	}
-#ifdef SIMD_COEF_32
+#if defined(SIMD_COEF_32) && ARCH_LITTLE_ENDIAN==1
 	alter_endianity(realcipher, BINARY_SIZE);
 #endif
 	return (void*)realcipher;
@@ -192,11 +196,16 @@ static void set_key(char *key, int index)
 	const uint32_t *wkey = (uint32_t*)(is_aligned(key, sizeof(uint32_t)) ?
 	                                       key : strcpy(buf_aligned, key));
 #endif
+#if ARCH_LITTLE_ENDIAN==1
 	uint32_t *keybuf_word = (uint32_t*)&saved_key[0][GETPOS(SALT_SIZE ^ 3, index)];
+#else
+	uint32_t *keybuf_word = (uint32_t*)&saved_key[0][GETPOS(SALT_SIZE, index)];
+#endif
 	unsigned int len;
 	uint32_t temp;
 
 	len = SALT_SIZE;
+#if ARCH_LITTLE_ENDIAN
 	while((temp = *wkey++) & 0xff) {
 		if (!(temp & 0xff00))
 		{
@@ -221,7 +230,32 @@ static void set_key(char *key, int index)
 		len += 4;
 	}
 	*keybuf_word = 0x00800000;
-
+#else
+	while((temp = *wkey++) & 0xff000000) {
+		if (!(temp & 0xff0000))
+		{
+			*keybuf_word = (temp & 0xff000000) | (0x80 << 8);
+			len++;
+			goto key_cleaning;
+		}
+		if (!(temp & 0xff00))
+		{
+			*keybuf_word = (temp & 0xffff0000) | (0x80);
+			len+=2;
+			goto key_cleaning;
+		}
+		*keybuf_word = temp;
+		keybuf_word += SIMD_COEF_32;
+		if (!(temp & 0xff))
+		{
+			*keybuf_word = 0x80000000;
+			len+=3;
+			goto key_cleaning;
+		}
+		len += 4;
+	}
+	*keybuf_word = 0x800000;
+#endif
 key_cleaning:
 	keybuf_word += SIMD_COEF_32;
 	while(*keybuf_word) {
diff --git a/src/simd-intrinsics.c b/src/simd-intrinsics.c
index f8e6cd81e8..3d64bc09ea 100644
--- a/src/simd-intrinsics.c
+++ b/src/simd-intrinsics.c
@@ -390,7 +390,6 @@ void SIMDmd5body(vtype* _data, unsigned int *out,
 #endif
 
 	if (SSEi_flags & SSEi_FLAT_OUT) {
-#if !ARCH_LITTLE_ENDIAN
 		MD5_PARA_DO(i)
 		{
 			uint32_t *o = (uint32_t*)&out[i*4*VS32];
@@ -411,17 +410,23 @@ void SIMDmd5body(vtype* _data, unsigned int *out,
 				uint32_t s[4 * VS32];
 			} tmp;
 
+#if ARCH_LITTLE_ENDIAN==1
+			tmp.v[0] = a[i];
+			tmp.v[1] = b[i];
+			tmp.v[2] = c[i];
+			tmp.v[3] = d[i];
+#else
 			tmp.v[0] = vswap32(a[i]);
 			tmp.v[1] = vswap32(b[i]);
 			tmp.v[2] = vswap32(c[i]);
 			tmp.v[3] = vswap32(d[i]);
+#endif
 
 			for (j = 0; j < VS32; j++)
 				for (k = 0; k < 4; k++)
 					o[j*4+k] = tmp.s[k*VS32+j];
 #endif
 		}
-#endif
 	}
 	else if (SSEi_flags & SSEi_OUTPUT_AS_INP_FMT)
 	{
@@ -1096,7 +1101,6 @@ void SIMDmd4body(vtype* _data, unsigned int *out, uint32_t *reload_state,
 #endif
 
 	if (SSEi_flags & SSEi_FLAT_OUT) {
-#if !ARCH_LITTLE_ENDIAN
 		MD4_PARA_DO(i)
 		{
 			uint32_t *o = (uint32_t*)&out[i*4*VS32];
@@ -1117,17 +1121,23 @@ void SIMDmd4body(vtype* _data, unsigned int *out, uint32_t *reload_state,
 				uint32_t s[4 * VS32];
 			} tmp;
 
+#if ARCH_LITTLE_ENDIAN==1
+			tmp.v[0] = a[i];
+			tmp.v[1] = b[i];
+			tmp.v[2] = c[i];
+			tmp.v[3] = d[i];
+#else
 			tmp.v[0] = vswap32(a[i]);
 			tmp.v[1] = vswap32(b[i]);
 			tmp.v[2] = vswap32(c[i]);
 			tmp.v[3] = vswap32(d[i]);
+#endif
 
 			for (j = 0; j < VS32; j++)
 				for (k = 0; k < 4; k++)
 					o[j*4+k] = tmp.s[k*VS32+j];
 #endif
 		}
-#endif
 	}
 	else if (SSEi_flags & SSEi_OUTPUT_AS_INP_FMT)
 	{
@@ -1604,7 +1614,6 @@ void SIMDSHA1body(vtype* _data, uint32_t *out, uint32_t *reload_state,
 	}
 
 	if (SSEi_flags & SSEi_FLAT_OUT) {
-#if ARCH_LITTLE_ENDIAN==1
 		SHA1_PARA_DO(i)
 		{
 			uint32_t *o = (uint32_t*)&out[i*5*VS32];
@@ -1626,18 +1635,25 @@ void SIMDSHA1body(vtype* _data, uint32_t *out, uint32_t *reload_state,
 				uint32_t s[5 * VS32];
 			} tmp;
 
+#if ARCH_LITTLE_ENDIAN==1
 			tmp.v[0] = vswap32(a[i]);
 			tmp.v[1] = vswap32(b[i]);
 			tmp.v[2] = vswap32(c[i]);
 			tmp.v[3] = vswap32(d[i]);
 			tmp.v[4] = vswap32(e[i]);
+#else
+			tmp.v[0] = a[i];
+			tmp.v[1] = b[i];
+			tmp.v[2] = c[i];
+			tmp.v[3] = d[i];
+			tmp.v[4] = e[i];
+#endif
 
 			for (j = 0; j < VS32; j++)
 				for (k = 0; k < 5; k++)
 					o[j*5+k] = tmp.s[k*VS32+j];
 #endif
 		}
-#endif
 	}
 	else if (SSEi_flags & SSEi_OUTPUT_AS_INP_FMT)
 	{
@@ -2165,7 +2181,6 @@ void SIMDSHA256body(vtype *data, uint32_t *out, uint32_t *reload_state, unsigned
 	}
 
 	if (SSEi_flags & SSEi_FLAT_OUT) {
-#if ARCH_LITTLE_ENDIAN==1
 		SHA256_PARA_DO(i)
 		{
 			uint32_t *o = (uint32_t*)&out[i*8*VS32];
@@ -2190,6 +2205,7 @@ void SIMDSHA256body(vtype *data, uint32_t *out, uint32_t *reload_state, unsigned
 				uint32_t s[8 * VS32];
 			} tmp;
 
+#if ARCH_LITTLE_ENDIAN==1
 			tmp.v[0] = vswap32(a[i]);
 			tmp.v[1] = vswap32(b[i]);
 			tmp.v[2] = vswap32(c[i]);
@@ -2198,13 +2214,22 @@ void SIMDSHA256body(vtype *data, uint32_t *out, uint32_t *reload_state, unsigned
 			tmp.v[5] = vswap32(f[i]);
 			tmp.v[6] = vswap32(g[i]);
 			tmp.v[7] = vswap32(h[i]);
+#else
+			tmp.v[0] = a[i];
+			tmp.v[1] = b[i];
+			tmp.v[2] = c[i];
+			tmp.v[3] = d[i];
+			tmp.v[4] = e[i];
+			tmp.v[5] = f[i];
+			tmp.v[6] = g[i];
+			tmp.v[7] = h[i];
+#endif
 
 			for (j = 0; j < VS32; j++)
 				for (k = 0; k < 8; k++)
 					o[j*8+k] = tmp.s[k*VS32+j];
 #endif
 		}
-#endif
 	}
 	else if (SSEi_flags & SSEi_OUTPUT_AS_INP_FMT) {
 		if ((SSEi_flags & SSEi_OUTPUT_AS_2BUF_INP_FMT) == SSEi_OUTPUT_AS_2BUF_INP_FMT) {
@@ -2735,7 +2760,6 @@ void SIMDSHA512body(vtype* data, uint64_t *out, uint64_t *reload_state,
 	}
 
 	if (SSEi_flags & SSEi_FLAT_OUT) {
-#if ARCH_LITTLE_ENDIAN==1
 		SHA512_PARA_DO(i)
 		{
 			uint64_t *o = (uint64_t*)&out[i*8*VS64];
@@ -2758,6 +2782,7 @@ void SIMDSHA512body(vtype* data, uint64_t *out, uint64_t *reload_state,
 				uint64_t s[8 * VS64];
 			} tmp;
 
+#if ARCH_LITTLE_ENDIAN==1
 			tmp.v[0] = vswap64(a[i]);
 			tmp.v[1] = vswap64(b[i]);
 			tmp.v[2] = vswap64(c[i]);
@@ -2766,13 +2791,21 @@ void SIMDSHA512body(vtype* data, uint64_t *out, uint64_t *reload_state,
 			tmp.v[5] = vswap64(f[i]);
 			tmp.v[6] = vswap64(g[i]);
 			tmp.v[7] = vswap64(h[i]);
-
+#else
+			tmp.v[0] = a[i];
+			tmp.v[1] = b[i];
+			tmp.v[2] = c[i];
+			tmp.v[3] = d[i];
+			tmp.v[4] = e[i];
+			tmp.v[5] = f[i];
+			tmp.v[6] = g[i];
+			tmp.v[7] = h[i];
+#endif
 			for (j = 0; j < VS64; j++)
 				for (k = 0; k < 8; k++)
 					o[j*8+k] = tmp.s[k*VS64+j];
 #endif
 		}
-#endif
 	}
 	else if (SSEi_flags & SSEi_OUTPUT_AS_INP_FMT)
 	{
